/*
 * 16F88_linetrace_r2
 * Cg[X{bg̃eXgpvO (__delay_ms()ɂ[PWM)
 * 
 * File:   main.c
 * Author: Taichi
 *
 * Created on 2017/11/08, 14:13
 */


// CONFIG1
#pragma config FOSC = INTOSCIO  // Oscillator Selection bits (INTRC oscillator; port I/O function on both RA6/OSC2/CLKO pin and RA7/OSC1/CLKI pin)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = OFF      // Power-up Timer Enable bit (PWRT disabled)
#pragma config MCLRE = ON       // RA5/MCLR/VPP Pin Function Select bit (RA5/MCLR/VPP pin function is MCLR)
#pragma config BOREN = ON       // Brown-out Reset Enable bit (BOR enabled)
#pragma config LVP = OFF        // Low-Voltage Programming Enable bit (RB3 is digital I/O, HV on MCLR must be used for programming)
#pragma config CPD = OFF        // Data EE Memory Code Protection bit (Code protection off)
#pragma config WRT = OFF        // Flash Program Memory Write Enable bits (Write protection off)
#pragma config CCPMX = RB3      // CCP1 Pin Selection bit (CCP1 function on RB3)
#pragma config CP = OFF         // Flash Program Memory Code Protection bit (Code protection off)

// CONFIG2
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable bit (Fail-Safe Clock Monitor disabled)
#pragma config IESO = OFF       // Internal External Switchover bit (Internal External Switchover mode disabled)

#include <xc.h>
#include <stdio.h>
#include "uart.h"

#define _XTAL_FREQ 8000000      // 8MHz


#define MOTOR_R RA0     // E[^
#define MOTOR_L RA1     // [^
#define SENSOR_R RA2    // EZT 
#define SENSOR_L RA3    // ZT 
#define LED_R RB1       // LED LowxhCu _
#define LED_L RB0       // LED LowxhCu _


void main(void) {
        
    OSCCON = 0b01110000;    // NbN̎g8MHzɐݒ
 
    PORTA = 0x00;           // PORTA
    PORTB = 0x00;           // PORTB
    TRISA = 0b00001100;     // PORTA̓o͐ݒ RA2,3SENSOR
    TRISB = 0b00000100;     // PORTB̓o͐ݒ RB2RX
    ANSEL = 0b00000000;     // ADRo[^
    
    initUART();             // VAʐMݒ
 
    __delay_ms(100);
    printf("Line Trace Start!\n");
    
    
    while(1){
        if(SENSOR_R==1){        // ẼZTmꍇ
            printf("Turn right\n");
            LED_R=1; // LEDLowxhCu _
            LED_L=0;
            MOTOR_L=1; // [^͑S͂ŉ]
            MOTOR_R=0; // E[^OFF/ONJԂ
            __delay_ms(40);
            MOTOR_R=1;
            __delay_ms(10);
        }
        else if(SENSOR_L==1){         // ̃ZTmꍇ
            printf("Turn left\n");
            LED_R=0;
            LED_L=1;
            MOTOR_R=1; // E[^͑S͂ŉ]
            MOTOR_L=0; // [^OFF/ONJԂ
            __delay_ms(40);
            MOTOR_L=1;
            __delay_ms(10);
            
        }
        else{                   // ȊȌꍇ
            printf("Go straight\n");
            LED_R=0;
            LED_L=0;
            MOTOR_R=1;
            MOTOR_L=1;
        }
    }
}
